/*********************************************************
** Nit header file                                      **                       
**                                                      **                                       
** Copyright 1993 DNPAP group.                          **                  
** Author(s): Richard Kooijman R.Kooijman@et.tudelft.nl **
**            Dirk Wisse       D.M.Wisse@et.tudelft.nl  **        
**                                                      **                                       
*********************************************************/

#ifndef _NIT_H_
#define _NIT_H_
    

#include <sys/types.h>
#include <sys/time.h>
#include <net/nit_if.h>
#include "type.h"


#define NITDEVICE       "/dev/nit"
#define NITFILTER       "pf"
#define NITBUFFER       "nbuf"

                      
enum NitErrors
{
    NIT_OK, NIT_CONFIG, NIT_NEWNIT, NIT_OPEN, NIT_ALLOC, 
    NIT_IOCTL, NIT_PUSH, NIT_CHECK, NIT_READ, NIT_WRITE
};

typedef struct _NIT
{
    INT fd;
    CHAR *interface;
    ULONG bufsize;
    ULONG snaplen;
    TIMEVAL timeout;
    ULONG flags;
    BYTE *buf;
    LONG  pos;
    LONG  end;
    
} NIT;


BOOLEAN NitInit(int argc, char *argv[]);
BOOLEAN NitExit(VOID);

NIT* NitOpen(const CHAR *interface, ULONG bufsize, ULONG snaplen, TIMEVAL timeout, ULONG flags, INT flags2);
VOID NitClose(NIT *nit);

INT NitHandle(NIT *nit);

INT NitCheck(NIT *nit, TIMEVAL *timeout, fd_set **fds);

BYTE *NitRead(NIT *nit, ULONG *msglen, ULONG *pktlen, TIMEVAL *timestamp, ULONG *drops);
INT NitWrite(NIT *nit, BYTE *packet, ULONG pktlen, INT flags);


#endif
